******* Borenstein, AEJ-EP, "The Redistributional Impact of Non-Linear Electricity Pricing"
******* See BorensteinAEJEPReadMe.txt for description
******* PROGRAM #14 CSCHGA2.DO

clear
capture log close
log using "CSchgA2.slf", replace text
set more off
set mem 1220m
 
u altratesa
 
summ rate51A
scalar r51A=r(mean)
summ rate52A
scalar r52A=r(mean)
summ rate53A
scalar r53A=r(mean)
summ rate54A
scalar r54A=r(mean)
summ rate55A
scalar r55A=r(mean)
summ rate21A
scalar r21A=r(mean)
summ rate22A
scalar r22A=r(mean)
summ rate11A
scalar r11A=r(mean)
 
save xxx,replace
 
capture erase cschgA2.dta
 

****** -------------------------  QUARTER 1 -----------------------------
 
local daycount=16802
while `daycount'<=16891{
 
display "DAYCOUNT = " `daycount'
 

u d:\dataslave\sce_2006q1_base_corrected_1222.dta
 
drop if days==0
 
drop if end_date<`daycount'
drop if end_date>`daycount'+13
 

drop base_pre
 
g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"
 

**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW 
 
g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0
 
drop if flaguse==0
 
compress
 

**  PRORATE BILLS AT BEGINNING OR END OF YEAR
 
drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802
 
replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio
replace base=base*dyratio
 
drop dyratio start_date end_date

g mrgprc=r51A
replace mrgprc=r52A if use2>0.0001
replace mrgprc=r53A if use3>0.0001
replace mrgprc=r54A if use4>0.0001
replace mrgprc=r55A if use5>0.0001

*g mrgprc=0.1162 if CARE==0
*replace mrgprc=0.1361 if CARE==0 & use2>0.0001
*replace mrgprc=0.2201 if CARE==0 & use3>0.0001
*replace mrgprc=0.3049 if CARE==0 & use4>0.0001
*replace mrgprc=0.3049 if CARE==0 & use5>0.0001
 
*replace mrgprc=0.0834 if CARE==1
*replace mrgprc=0.1053 if CARE==1 & use2>0.0001
*replace mrgprc=0.1691 if CARE==1 & use3>0.0001
*replace mrgprc=0.1717 if CARE==1 & use4>0.0001
*replace mrgprc=0.1717 if CARE==1 & use5>0.0001
 
*g dmdcnst0=use
*g dmdcnst1=use/(mrgprc^-0.1)
g dmdcnst2=use/(mrgprc^-0.2)
g dmdcnst3=use/(mrgprc^-0.3)
 
summ use if use<0
 
keep id aid days use base dmd* CARE
 

g dmd2q5=dmdcnst2*r51A^-0.2 if dmdcnst2*r51A^-0.2<base
replace dmd2q5=base if dmdcnst2*r51A^-0.2>=base &  dmdcnst2*r52A^-0.2<=base
replace dmd2q5=dmdcnst2*r52A^-0.2 if dmdcnst2*r52A^-0.2>base &  dmdcnst2*r52A^-0.2<1.3*base
replace dmd2q5=1.3*base if dmdcnst2*r52A^-0.2>=1.3*base &  dmdcnst2*r53A^-0.2<=1.3*base
replace dmd2q5=dmdcnst2*r53A^-0.2 if dmdcnst2*r53A^-0.2>1.3*base &  dmdcnst2*r53A^-0.2<2*base
replace dmd2q5=2*base if dmdcnst2*r53A^-0.2>=2*base &  dmdcnst2*r54A^-0.2<=2*base
replace dmd2q5=dmdcnst2*r54A^-0.2 if dmdcnst2*r54A^-0.2>2*base &  dmdcnst2*r54A^-0.2<3*base
replace dmd2q5=3*base if dmdcnst2*r54A^-0.2>=3*base &  dmdcnst2*r55A^-0.2<=3*base
replace dmd2q5=dmdcnst2*r55A^-0.2 if dmdcnst2*r55A^-0.2>3*base 
 
g dmd2q2=dmdcnst2*r21A^-0.2 if dmdcnst2*r21A^-0.2<base
replace dmd2q2=base if dmdcnst2*r21A^-0.2>=base &  dmdcnst2*r22A^-0.2<=base
replace dmd2q2=dmdcnst2*r22A^-0.2 if dmdcnst2*r22A^-0.2>base 
 
g dmd2q1=dmdcnst2*r11A^-0.2 
 
 
 
g dmd3q5=dmdcnst3*r51A^-0.3 if dmdcnst3*r51A^-0.3<base
replace dmd3q5=base if dmdcnst3*r51A^-0.3>=base &  dmdcnst3*r52A^-0.3<=base
replace dmd3q5=dmdcnst3*r52A^-0.3 if dmdcnst3*r52A^-0.3>base &  dmdcnst3*r52A^-0.3<1.3*base
replace dmd3q5=1.3*base if dmdcnst3*r52A^-0.3>=1.3*base &  dmdcnst3*r53A^-0.3<=1.3*base
replace dmd3q5=dmdcnst3*r53A^-0.3 if dmdcnst3*r53A^-0.3>1.3*base &  dmdcnst3*r53A^-0.3<2*base
replace dmd3q5=2*base if dmdcnst3*r53A^-0.3>=2*base &  dmdcnst3*r54A^-0.3<=2*base
replace dmd3q5=dmdcnst3*r54A^-0.3 if dmdcnst3*r54A^-0.3>2*base &  dmdcnst3*r54A^-0.3<3*base
replace dmd3q5=3*base if dmdcnst3*r54A^-0.3>=3*base &  dmdcnst3*r55A^-0.3<=3*base
replace dmd3q5=dmdcnst3*r55A^-0.3 if dmdcnst3*r55A^-0.3>3*base 
 
g dmd3q2=dmdcnst3*r21A^-0.3 if dmdcnst3*r21A^-0.3<base
replace dmd3q2=base if dmdcnst3*r21A^-0.3>=base &  dmdcnst3*r22A^-0.3<=base
replace dmd3q2=dmdcnst3*r22A^-0.3 if dmdcnst3*r22A^-0.3>base 
 
g dmd3q1=dmdcnst3*r11A^-0.3 
 
* assume that demand is zero elasticity if use<0
 
replace dmd2q5=use if use<0
replace dmd2q2=use if use<0
replace dmd2q1=use if use<0
 
replace dmd3q5=use if use<0
replace dmd3q2=use if use<0
replace dmd3q1=use if use<0
 
 
 

**** CALC CHG IN CS BY CALC TOTAL CS BELOW P=0.5
 
g cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r51A^0.8)/0.8) if dmd2q5<base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r52A^0.8)/0.8) + base*(r52A-r51A) if dmd2q5>=base & dmd2q5<1.3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r53A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd2q5>=1.3*base & dmd2q5<2*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r54A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd2q5>=2*base & dmd2q5<3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r55A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd2q5>=3*base
 
g cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r21A^0.8)/0.8) if dmd2q2<base
replace cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r22A^0.8)/0.8) + base*(r22A-r21A) if dmd2q2>=base 
 
g cs2t1=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r11A^0.8)/0.8) 
 

g cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r51A^0.7)/0.7) if dmd3q5<base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r52A^0.7)/0.7) + base*(r52A-r51A) if dmd3q5>=base & dmd3q5<1.3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r53A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd3q5>=1.3*base & dmd3q5<2*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r54A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd3q5>=2*base & dmd3q5<3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r55A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd3q5>=3*base
 
g cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r21A^0.7)/0.7) if dmd3q2<base
replace cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r22A^0.7)/0.7) + base*(r22A-r21A) if dmd3q2>=base 
 
g cs3t1=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r11A^0.7)/0.7) 
 

*counting solar "producer surplus" if use<0
 
replace cs2t5=-(use*r51A) if use<0
replace cs2t2=-(use*r21A) if use<0
replace cs2t1=-(use*r11A) if use<0
 
replace cs3t5=-(use*r51A) if use<0
replace cs3t2=-(use*r21A) if use<0
replace cs3t1=-(use*r11A) if use<0
 

summ
 
drop dmdcnst*
 
**** CALC REV PAID
g rv2t5=r51A*dmd2q5 if dmd2q5<base
replace rv2t5=r51A*base + r52A*(dmd2q5-base) if dmd2q5>=base & dmd2q5<1.3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A* (dmd2q5-1.3* base) if dmd2q5>=1.3*base & dmd2q5<2*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd2q5-2* base) if dmd2q5>=2*base & dmd2q5<3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd2q5-3* base) if dmd2q5>=3*base
 
g rv2t2=r21A*dmd2q2 if dmd2q2<base
replace rv2t2=r21A*base + r22A*(dmd2q2-base) if dmd2q5>=base 
 
g rv2t1=r11A*dmd2q1
 

g rv3t5=r51A*dmd3q5 if dmd3q5<base
replace rv3t5=r51A*base + r52A*(dmd3q5-base) if dmd3q5>=base & dmd3q5<1.3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A* (dmd3q5-1.3* base) if dmd3q5>=1.3*base & dmd3q5<2*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd3q5-2* base) if dmd3q5>=2*base & dmd3q5<3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd3q5-3* base) if dmd3q5>=3*base
 
g rv3t2=r21A*dmd3q2 if dmd3q2<base
replace rv3t2=r21A*base + r22A*(dmd3q2-base) if dmd3q5>=base 
 
g rv3t1=r11A*dmd3q1
 

capture append using CSchgA2
 
sort id aid CARE
 
collapse (sum) days use dmd* cs* rv*, by(id aid CARE)
 
compress
save CSchgA2, replace
 
local daycount=`daycount'+14
 
}
 
 
 
****** -------------------------  QUARTER 2 -----------------------------
 
local daycount=16891
while `daycount'<=16981{
 
display "DAYCOUNT = " `daycount'
 

u d:\dataslave\sce_2006q2_base_corrected_1222.dta
 
drop if days==0
 
drop if end_date<`daycount'
drop if end_date>`daycount'+13
 

drop base_pre
 
g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"
 

**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW 
 
g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0
 
drop if flaguse==0
 
compress
 

**  PRORATE BILLS AT BEGINNING OR END OF YEAR
 
drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802
 
replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio
replace base=base*dyratio
 
drop dyratio start_date end_date
 
g mrgprc=r51A
replace mrgprc=r52A if use2>0.0001
replace mrgprc=r53A if use3>0.0001
replace mrgprc=r54A if use4>0.0001
replace mrgprc=r55A if use5>0.0001

*g mrgprc=0.1162 if CARE==0
*replace mrgprc=0.1361 if CARE==0 & use2>0.0001
*replace mrgprc=0.2201 if CARE==0 & use3>0.0001
*replace mrgprc=0.3049 if CARE==0 & use4>0.0001
*replace mrgprc=0.3049 if CARE==0 & use5>0.0001
 
*replace mrgprc=0.0834 if CARE==1
*replace mrgprc=0.1053 if CARE==1 & use2>0.0001
*replace mrgprc=0.1691 if CARE==1 & use3>0.0001
*replace mrgprc=0.1717 if CARE==1 & use4>0.0001
*replace mrgprc=0.1717 if CARE==1 & use5>0.0001
 
*g dmdcnst0=use
*g dmdcnst1=use/(mrgprc^-0.1)
g dmdcnst2=use/(mrgprc^-0.2)
g dmdcnst3=use/(mrgprc^-0.3)
 
summ use if use<0
 
keep id aid days use base dmd* CARE
 

g dmd2q5=dmdcnst2*r51A^-0.2 if dmdcnst2*r51A^-0.2<base
replace dmd2q5=base if dmdcnst2*r51A^-0.2>=base &  dmdcnst2*r52A^-0.2<=base
replace dmd2q5=dmdcnst2*r52A^-0.2 if dmdcnst2*r52A^-0.2>base &  dmdcnst2*r52A^-0.2<1.3*base
replace dmd2q5=1.3*base if dmdcnst2*r52A^-0.2>=1.3*base &  dmdcnst2*r53A^-0.2<=1.3*base
replace dmd2q5=dmdcnst2*r53A^-0.2 if dmdcnst2*r53A^-0.2>1.3*base &  dmdcnst2*r53A^-0.2<2*base
replace dmd2q5=2*base if dmdcnst2*r53A^-0.2>=2*base &  dmdcnst2*r54A^-0.2<=2*base
replace dmd2q5=dmdcnst2*r54A^-0.2 if dmdcnst2*r54A^-0.2>2*base &  dmdcnst2*r54A^-0.2<3*base
replace dmd2q5=3*base if dmdcnst2*r54A^-0.2>=3*base &  dmdcnst2*r55A^-0.2<=3*base
replace dmd2q5=dmdcnst2*r55A^-0.2 if dmdcnst2*r55A^-0.2>3*base 
 
g dmd2q2=dmdcnst2*r21A^-0.2 if dmdcnst2*r21A^-0.2<base
replace dmd2q2=base if dmdcnst2*r21A^-0.2>=base &  dmdcnst2*r22A^-0.2<=base
replace dmd2q2=dmdcnst2*r22A^-0.2 if dmdcnst2*r22A^-0.2>base 
 
g dmd2q1=dmdcnst2*r11A^-0.2 
 
 
 
g dmd3q5=dmdcnst3*r51A^-0.3 if dmdcnst3*r51A^-0.3<base
replace dmd3q5=base if dmdcnst3*r51A^-0.3>=base &  dmdcnst3*r52A^-0.3<=base
replace dmd3q5=dmdcnst3*r52A^-0.3 if dmdcnst3*r52A^-0.3>base &  dmdcnst3*r52A^-0.3<1.3*base
replace dmd3q5=1.3*base if dmdcnst3*r52A^-0.3>=1.3*base &  dmdcnst3*r53A^-0.3<=1.3*base
replace dmd3q5=dmdcnst3*r53A^-0.3 if dmdcnst3*r53A^-0.3>1.3*base &  dmdcnst3*r53A^-0.3<2*base
replace dmd3q5=2*base if dmdcnst3*r53A^-0.3>=2*base &  dmdcnst3*r54A^-0.3<=2*base
replace dmd3q5=dmdcnst3*r54A^-0.3 if dmdcnst3*r54A^-0.3>2*base &  dmdcnst3*r54A^-0.3<3*base
replace dmd3q5=3*base if dmdcnst3*r54A^-0.3>=3*base &  dmdcnst3*r55A^-0.3<=3*base
replace dmd3q5=dmdcnst3*r55A^-0.3 if dmdcnst3*r55A^-0.3>3*base 
 
g dmd3q2=dmdcnst3*r21A^-0.3 if dmdcnst3*r21A^-0.3<base
replace dmd3q2=base if dmdcnst3*r21A^-0.3>=base &  dmdcnst3*r22A^-0.3<=base
replace dmd3q2=dmdcnst3*r22A^-0.3 if dmdcnst3*r22A^-0.3>base 
 
g dmd3q1=dmdcnst3*r11A^-0.3 
 
* assume that demand is zero elasticity if use<0
 
replace dmd2q5=use if use<0
replace dmd2q2=use if use<0
replace dmd2q1=use if use<0
 
replace dmd3q5=use if use<0
replace dmd3q2=use if use<0
replace dmd3q1=use if use<0
 
 
 

**** CALC CHG IN CS BY CALC TOTAL CS BELOW P=0.5
 
g cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r51A^0.8)/0.8) if dmd2q5<base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r52A^0.8)/0.8) + base*(r52A-r51A) if dmd2q5>=base & dmd2q5<1.3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r53A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd2q5>=1.3*base & dmd2q5<2*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r54A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd2q5>=2*base & dmd2q5<3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r55A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd2q5>=3*base
 
g cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r21A^0.8)/0.8) if dmd2q2<base
replace cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r22A^0.8)/0.8) + base*(r22A-r21A) if dmd2q2>=base 
 
g cs2t1=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r11A^0.8)/0.8) 
 

g cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r51A^0.7)/0.7) if dmd3q5<base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r52A^0.7)/0.7) + base*(r52A-r51A) if dmd3q5>=base & dmd3q5<1.3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r53A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd3q5>=1.3*base & dmd3q5<2*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r54A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd3q5>=2*base & dmd3q5<3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r55A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd3q5>=3*base
 
g cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r21A^0.7)/0.7) if dmd3q2<base
replace cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r22A^0.7)/0.7) + base*(r22A-r21A) if dmd3q2>=base 
 
g cs3t1=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r11A^0.7)/0.7) 
 

*counting solar "producer surplus" if use<0
 
replace cs2t5=-(use*r51A) if use<0
replace cs2t2=-(use*r21A) if use<0
replace cs2t1=-(use*r11A) if use<0
 
replace cs3t5=-(use*r51A) if use<0
replace cs3t2=-(use*r21A) if use<0
replace cs3t1=-(use*r11A) if use<0
 

summ
 
drop dmdcnst*
 
**** CALC REV PAID
g rv2t5=r51A*dmd2q5 if dmd2q5<base
replace rv2t5=r51A*base + r52A*(dmd2q5-base) if dmd2q5>=base & dmd2q5<1.3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A* (dmd2q5-1.3* base) if dmd2q5>=1.3*base & dmd2q5<2*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd2q5-2* base) if dmd2q5>=2*base & dmd2q5<3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd2q5-3* base) if dmd2q5>=3*base
 
g rv2t2=r21A*dmd2q2 if dmd2q2<base
replace rv2t2=r21A*base + r22A*(dmd2q2-base) if dmd2q5>=base 
 
g rv2t1=r11A*dmd2q1
 

g rv3t5=r51A*dmd3q5 if dmd3q5<base
replace rv3t5=r51A*base + r52A*(dmd3q5-base) if dmd3q5>=base & dmd3q5<1.3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A* (dmd3q5-1.3* base) if dmd3q5>=1.3*base & dmd3q5<2*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd3q5-2* base) if dmd3q5>=2*base & dmd3q5<3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd3q5-3* base) if dmd3q5>=3*base
 
g rv3t2=r21A*dmd3q2 if dmd3q2<base
replace rv3t2=r21A*base + r22A*(dmd3q2-base) if dmd3q5>=base 
 
g rv3t1=r11A*dmd3q1
 

capture append using CSchgA2
 
sort id aid CARE
 
collapse (sum) days use dmd* cs* rv*, by(id aid CARE)
 
compress
save CSchgA2, replace
 
local daycount=`daycount'+14
 
}
 
 
 
 
 
****** -------------------------  QUARTER 3 -----------------------------
 
local daycount=16981
while `daycount'<=17071{
 
display "DAYCOUNT = " `daycount'
 

u d:\dataslave\sce_2006q3_base_corrected_1222.dta
 
drop if days==0
 
drop if end_date<`daycount'
drop if end_date>`daycount'+13
 

drop base_pre
 
g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"
 

**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW 
 
g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0
 
drop if flaguse==0
 
compress
 

**  PRORATE BILLS AT BEGINNING OR END OF YEAR
 
drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802
 
replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio
replace base=base*dyratio
 
drop dyratio start_date end_date

g mrgprc=r51A
replace mrgprc=r52A if use2>0.0001
replace mrgprc=r53A if use3>0.0001
replace mrgprc=r54A if use4>0.0001
replace mrgprc=r55A if use5>0.0001
 
*g mrgprc=0.1162 if CARE==0
*replace mrgprc=0.1361 if CARE==0 & use2>0.0001
*replace mrgprc=0.2201 if CARE==0 & use3>0.0001
*replace mrgprc=0.3049 if CARE==0 & use4>0.0001
*replace mrgprc=0.3049 if CARE==0 & use5>0.0001
 
*replace mrgprc=0.0834 if CARE==1
*replace mrgprc=0.1053 if CARE==1 & use2>0.0001
*replace mrgprc=0.1691 if CARE==1 & use3>0.0001
*replace mrgprc=0.1717 if CARE==1 & use4>0.0001
*replace mrgprc=0.1717 if CARE==1 & use5>0.0001
 
*g dmdcnst0=use
*g dmdcnst1=use/(mrgprc^-0.1)
g dmdcnst2=use/(mrgprc^-0.2)
g dmdcnst3=use/(mrgprc^-0.3)
 
summ use if use<0
 
keep id aid days use base dmd* CARE
 

g dmd2q5=dmdcnst2*r51A^-0.2 if dmdcnst2*r51A^-0.2<base
replace dmd2q5=base if dmdcnst2*r51A^-0.2>=base &  dmdcnst2*r52A^-0.2<=base
replace dmd2q5=dmdcnst2*r52A^-0.2 if dmdcnst2*r52A^-0.2>base &  dmdcnst2*r52A^-0.2<1.3*base
replace dmd2q5=1.3*base if dmdcnst2*r52A^-0.2>=1.3*base &  dmdcnst2*r53A^-0.2<=1.3*base
replace dmd2q5=dmdcnst2*r53A^-0.2 if dmdcnst2*r53A^-0.2>1.3*base &  dmdcnst2*r53A^-0.2<2*base
replace dmd2q5=2*base if dmdcnst2*r53A^-0.2>=2*base &  dmdcnst2*r54A^-0.2<=2*base
replace dmd2q5=dmdcnst2*r54A^-0.2 if dmdcnst2*r54A^-0.2>2*base &  dmdcnst2*r54A^-0.2<3*base
replace dmd2q5=3*base if dmdcnst2*r54A^-0.2>=3*base &  dmdcnst2*r55A^-0.2<=3*base
replace dmd2q5=dmdcnst2*r55A^-0.2 if dmdcnst2*r55A^-0.2>3*base 
 
g dmd2q2=dmdcnst2*r21A^-0.2 if dmdcnst2*r21A^-0.2<base
replace dmd2q2=base if dmdcnst2*r21A^-0.2>=base &  dmdcnst2*r22A^-0.2<=base
replace dmd2q2=dmdcnst2*r22A^-0.2 if dmdcnst2*r22A^-0.2>base 
 
g dmd2q1=dmdcnst2*r11A^-0.2 
 
 
 
g dmd3q5=dmdcnst3*r51A^-0.3 if dmdcnst3*r51A^-0.3<base
replace dmd3q5=base if dmdcnst3*r51A^-0.3>=base &  dmdcnst3*r52A^-0.3<=base
replace dmd3q5=dmdcnst3*r52A^-0.3 if dmdcnst3*r52A^-0.3>base &  dmdcnst3*r52A^-0.3<1.3*base
replace dmd3q5=1.3*base if dmdcnst3*r52A^-0.3>=1.3*base &  dmdcnst3*r53A^-0.3<=1.3*base
replace dmd3q5=dmdcnst3*r53A^-0.3 if dmdcnst3*r53A^-0.3>1.3*base &  dmdcnst3*r53A^-0.3<2*base
replace dmd3q5=2*base if dmdcnst3*r53A^-0.3>=2*base &  dmdcnst3*r54A^-0.3<=2*base
replace dmd3q5=dmdcnst3*r54A^-0.3 if dmdcnst3*r54A^-0.3>2*base &  dmdcnst3*r54A^-0.3<3*base
replace dmd3q5=3*base if dmdcnst3*r54A^-0.3>=3*base &  dmdcnst3*r55A^-0.3<=3*base
replace dmd3q5=dmdcnst3*r55A^-0.3 if dmdcnst3*r55A^-0.3>3*base 
 
g dmd3q2=dmdcnst3*r21A^-0.3 if dmdcnst3*r21A^-0.3<base
replace dmd3q2=base if dmdcnst3*r21A^-0.3>=base &  dmdcnst3*r22A^-0.3<=base
replace dmd3q2=dmdcnst3*r22A^-0.3 if dmdcnst3*r22A^-0.3>base 
 
g dmd3q1=dmdcnst3*r11A^-0.3 
 
* assume that demand is zero elasticity if use<0
 
replace dmd2q5=use if use<0
replace dmd2q2=use if use<0
replace dmd2q1=use if use<0
 
replace dmd3q5=use if use<0
replace dmd3q2=use if use<0
replace dmd3q1=use if use<0
 
 
 

**** CALC CHG IN CS BY CALC TOTAL CS BELOW P=0.5
 
g cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r51A^0.8)/0.8) if dmd2q5<base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r52A^0.8)/0.8) + base*(r52A-r51A) if dmd2q5>=base & dmd2q5<1.3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r53A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd2q5>=1.3*base & dmd2q5<2*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r54A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd2q5>=2*base & dmd2q5<3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r55A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd2q5>=3*base
 
g cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r21A^0.8)/0.8) if dmd2q2<base
replace cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r22A^0.8)/0.8) + base*(r22A-r21A) if dmd2q2>=base 
 
g cs2t1=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r11A^0.8)/0.8) 
 

g cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r51A^0.7)/0.7) if dmd3q5<base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r52A^0.7)/0.7) + base*(r52A-r51A) if dmd3q5>=base & dmd3q5<1.3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r53A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd3q5>=1.3*base & dmd3q5<2*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r54A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd3q5>=2*base & dmd3q5<3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r55A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd3q5>=3*base
 
g cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r21A^0.7)/0.7) if dmd3q2<base
replace cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r22A^0.7)/0.7) + base*(r22A-r21A) if dmd3q2>=base 
 
g cs3t1=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r11A^0.7)/0.7) 
 

*counting solar "producer surplus" if use<0
 
replace cs2t5=-(use*r51A) if use<0
replace cs2t2=-(use*r21A) if use<0
replace cs2t1=-(use*r11A) if use<0
 
replace cs3t5=-(use*r51A) if use<0
replace cs3t2=-(use*r21A) if use<0
replace cs3t1=-(use*r11A) if use<0
 

summ
 
drop dmdcnst*
 
**** CALC REV PAID
g rv2t5=r51A*dmd2q5 if dmd2q5<base
replace rv2t5=r51A*base + r52A*(dmd2q5-base) if dmd2q5>=base & dmd2q5<1.3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A* (dmd2q5-1.3* base) if dmd2q5>=1.3*base & dmd2q5<2*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd2q5-2* base) if dmd2q5>=2*base & dmd2q5<3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd2q5-3* base) if dmd2q5>=3*base
 
g rv2t2=r21A*dmd2q2 if dmd2q2<base
replace rv2t2=r21A*base + r22A*(dmd2q2-base) if dmd2q5>=base 
 
g rv2t1=r11A*dmd2q1
 

g rv3t5=r51A*dmd3q5 if dmd3q5<base
replace rv3t5=r51A*base + r52A*(dmd3q5-base) if dmd3q5>=base & dmd3q5<1.3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A* (dmd3q5-1.3* base) if dmd3q5>=1.3*base & dmd3q5<2*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd3q5-2* base) if dmd3q5>=2*base & dmd3q5<3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd3q5-3* base) if dmd3q5>=3*base
 
g rv3t2=r21A*dmd3q2 if dmd3q2<base
replace rv3t2=r21A*base + r22A*(dmd3q2-base) if dmd3q5>=base 
 
g rv3t1=r11A*dmd3q1
 

capture append using CSchgA2
 
sort id aid CARE
 
collapse (sum) days use dmd* cs* rv*, by(id aid CARE)
 
compress
save CSchgA2, replace
 
local daycount=`daycount'+14
 

}
 
 
 
 
 

****** -------------------------  QUARTER 4 -----------------------------
 
local daycount=17071
while `daycount'<=17161{
 
display "DAYCOUNT = " `daycount'
 

u d:\dataslave\sce_2006q4_base_corrected_1222.dta
 
drop if days==0
 
drop if end_date<`daycount'
drop if end_date>`daycount'+13
 

drop base_pre
 
g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"
 

**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW 
 
g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0
 
drop if flaguse==0
 
compress
 

**  PRORATE BILLS AT BEGINNING OR END OF YEAR
 
drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802
 
replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio
replace base=base*dyratio
 
drop dyratio start_date end_date

g mrgprc=r51A
replace mrgprc=r52A if use2>0.0001
replace mrgprc=r53A if use3>0.0001
replace mrgprc=r54A if use4>0.0001
replace mrgprc=r55A if use5>0.0001
 
*g mrgprc=0.1162 if CARE==0
*replace mrgprc=0.1361 if CARE==0 & use2>0.0001
*replace mrgprc=0.2201 if CARE==0 & use3>0.0001
*replace mrgprc=0.3049 if CARE==0 & use4>0.0001
*replace mrgprc=0.3049 if CARE==0 & use5>0.0001
 
*replace mrgprc=0.0834 if CARE==1
*replace mrgprc=0.1053 if CARE==1 & use2>0.0001
*replace mrgprc=0.1691 if CARE==1 & use3>0.0001
*replace mrgprc=0.1717 if CARE==1 & use4>0.0001
*replace mrgprc=0.1717 if CARE==1 & use5>0.0001
 
*g dmdcnst0=use
*g dmdcnst1=use/(mrgprc^-0.1)
g dmdcnst2=use/(mrgprc^-0.2)
g dmdcnst3=use/(mrgprc^-0.3)
 
summ use if use<0
 
keep id aid days use base dmd* CARE
 

g dmd2q5=dmdcnst2*r51A^-0.2 if dmdcnst2*r51A^-0.2<base
replace dmd2q5=base if dmdcnst2*r51A^-0.2>=base &  dmdcnst2*r52A^-0.2<=base
replace dmd2q5=dmdcnst2*r52A^-0.2 if dmdcnst2*r52A^-0.2>base &  dmdcnst2*r52A^-0.2<1.3*base
replace dmd2q5=1.3*base if dmdcnst2*r52A^-0.2>=1.3*base &  dmdcnst2*r53A^-0.2<=1.3*base
replace dmd2q5=dmdcnst2*r53A^-0.2 if dmdcnst2*r53A^-0.2>1.3*base &  dmdcnst2*r53A^-0.2<2*base
replace dmd2q5=2*base if dmdcnst2*r53A^-0.2>=2*base &  dmdcnst2*r54A^-0.2<=2*base
replace dmd2q5=dmdcnst2*r54A^-0.2 if dmdcnst2*r54A^-0.2>2*base &  dmdcnst2*r54A^-0.2<3*base
replace dmd2q5=3*base if dmdcnst2*r54A^-0.2>=3*base &  dmdcnst2*r55A^-0.2<=3*base
replace dmd2q5=dmdcnst2*r55A^-0.2 if dmdcnst2*r55A^-0.2>3*base 
 
g dmd2q2=dmdcnst2*r21A^-0.2 if dmdcnst2*r21A^-0.2<base
replace dmd2q2=base if dmdcnst2*r21A^-0.2>=base &  dmdcnst2*r22A^-0.2<=base
replace dmd2q2=dmdcnst2*r22A^-0.2 if dmdcnst2*r22A^-0.2>base 
 
g dmd2q1=dmdcnst2*r11A^-0.2 
 
 
 
g dmd3q5=dmdcnst3*r51A^-0.3 if dmdcnst3*r51A^-0.3<base
replace dmd3q5=base if dmdcnst3*r51A^-0.3>=base &  dmdcnst3*r52A^-0.3<=base
replace dmd3q5=dmdcnst3*r52A^-0.3 if dmdcnst3*r52A^-0.3>base &  dmdcnst3*r52A^-0.3<1.3*base
replace dmd3q5=1.3*base if dmdcnst3*r52A^-0.3>=1.3*base &  dmdcnst3*r53A^-0.3<=1.3*base
replace dmd3q5=dmdcnst3*r53A^-0.3 if dmdcnst3*r53A^-0.3>1.3*base &  dmdcnst3*r53A^-0.3<2*base
replace dmd3q5=2*base if dmdcnst3*r53A^-0.3>=2*base &  dmdcnst3*r54A^-0.3<=2*base
replace dmd3q5=dmdcnst3*r54A^-0.3 if dmdcnst3*r54A^-0.3>2*base &  dmdcnst3*r54A^-0.3<3*base
replace dmd3q5=3*base if dmdcnst3*r54A^-0.3>=3*base &  dmdcnst3*r55A^-0.3<=3*base
replace dmd3q5=dmdcnst3*r55A^-0.3 if dmdcnst3*r55A^-0.3>3*base 
 
g dmd3q2=dmdcnst3*r21A^-0.3 if dmdcnst3*r21A^-0.3<base
replace dmd3q2=base if dmdcnst3*r21A^-0.3>=base &  dmdcnst3*r22A^-0.3<=base
replace dmd3q2=dmdcnst3*r22A^-0.3 if dmdcnst3*r22A^-0.3>base 
 
g dmd3q1=dmdcnst3*r11A^-0.3 
 
* assume that demand is zero elasticity if use<0
 
replace dmd2q5=use if use<0
replace dmd2q2=use if use<0
replace dmd2q1=use if use<0
 
replace dmd3q5=use if use<0
replace dmd3q2=use if use<0
replace dmd3q1=use if use<0
 
 
 

**** CALC CHG IN CS BY CALC TOTAL CS BELOW P=0.5
 
g cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r51A^0.8)/0.8) if dmd2q5<base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r52A^0.8)/0.8) + base*(r52A-r51A) if dmd2q5>=base & dmd2q5<1.3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r53A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd2q5>=1.3*base & dmd2q5<2*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r54A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd2q5>=2*base & dmd2q5<3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r55A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd2q5>=3*base
 
g cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r21A^0.8)/0.8) if dmd2q2<base
replace cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r22A^0.8)/0.8) + base*(r22A-r21A) if dmd2q2>=base 
 
g cs2t1=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r11A^0.8)/0.8) 
 

g cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r51A^0.7)/0.7) if dmd3q5<base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r52A^0.7)/0.7) + base*(r52A-r51A) if dmd3q5>=base & dmd3q5<1.3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r53A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd3q5>=1.3*base & dmd3q5<2*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r54A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd3q5>=2*base & dmd3q5<3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r55A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd3q5>=3*base
 
g cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r21A^0.7)/0.7) if dmd3q2<base
replace cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r22A^0.7)/0.7) + base*(r22A-r21A) if dmd3q2>=base 
 
g cs3t1=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r11A^0.7)/0.7) 
 

*counting solar "producer surplus" if use<0
 
replace cs2t5=-(use*r51A) if use<0
replace cs2t2=-(use*r21A) if use<0
replace cs2t1=-(use*r11A) if use<0
 
replace cs3t5=-(use*r51A) if use<0
replace cs3t2=-(use*r21A) if use<0
replace cs3t1=-(use*r11A) if use<0
 

summ
 
drop dmdcnst*
 
**** CALC REV PAID
g rv2t5=r51A*dmd2q5 if dmd2q5<base
replace rv2t5=r51A*base + r52A*(dmd2q5-base) if dmd2q5>=base & dmd2q5<1.3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A* (dmd2q5-1.3* base) if dmd2q5>=1.3*base & dmd2q5<2*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd2q5-2* base) if dmd2q5>=2*base & dmd2q5<3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd2q5-3* base) if dmd2q5>=3*base
 
g rv2t2=r21A*dmd2q2 if dmd2q2<base
replace rv2t2=r21A*base + r22A*(dmd2q2-base) if dmd2q5>=base 
 
g rv2t1=r11A*dmd2q1
 

g rv3t5=r51A*dmd3q5 if dmd3q5<base
replace rv3t5=r51A*base + r52A*(dmd3q5-base) if dmd3q5>=base & dmd3q5<1.3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A* (dmd3q5-1.3* base) if dmd3q5>=1.3*base & dmd3q5<2*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd3q5-2* base) if dmd3q5>=2*base & dmd3q5<3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd3q5-3* base) if dmd3q5>=3*base
 
g rv3t2=r21A*dmd3q2 if dmd3q2<base
replace rv3t2=r21A*base + r22A*(dmd3q2-base) if dmd3q5>=base 
 
g rv3t1=r11A*dmd3q1
 

capture append using CSchgA2
 
sort id aid CARE
 
collapse (sum) days use dmd* cs* rv*, by(id aid CARE)
 
compress
save CSchgA2, replace
 
local daycount=`daycount'+14
 
}
 
 
 
 
 
 
 

****** -------------------------  QUARTER 5 -----------------------------
 
local daycount=17161
while `daycount'<=17251{
 
display "DAYCOUNT = " `daycount'
 

u d:\dataslave\sce_2007q1_base_corrected_1222.dta
 
drop if days==0
 
drop if end_date<`daycount'
drop if end_date>`daycount'+13
 

drop base_pre
 
g byte CARE=0
replace CARE=1 if tariff=="D-CARE"
replace CARE=1 if tariff=="D-CARE-APS"
replace CARE=1 if tariff=="D-CARE-APS-E"
replace CARE=1 if tariff=="D-S-CARE"
replace CARE=1 if tariff=="TOU-D-1-CARE"
replace CARE=1 if tariff=="TOU-D-2-CARE"
replace CARE=1 if tariff=="TOU-DCARE-SP"
 

**  IDENTIFY OBSERVATIONS WITH EXCESSIVELY LOW 
 
g flaguse=1
replace flaguse=0 if use/days<1 & use>=0
replace flaguse=0 if days<=0
 
drop if flaguse==0
 
compress
 

**  PRORATE BILLS AT BEGINNING OR END OF YEAR
 
drop if end_date<16802
drop if start_date> 17166
g dyratio=1
*NEED TO ADJUST FOR THE FACT THAT METERS ARE USUALLY READ NEARER TO MID-DAY THAN BEGINNING OR END
* SO CROSSING YEAR BOUNDARY GIVES HALF DAY
replace dyratio= ((end_date+0.5)-16802)/(end_date-start_date) if start_date< 16802
replace dyratio= (17166+0.5-start_date)/(end_date-start_date) if end_date>17166
replace dyratio= (365/(end_date-start_date)) if end_date>17166 &  start_date< 16802
 
replace rev=rev*dyratio
replace days= days*dyratio
replace use=use*dyratio
replace use1=use1*dyratio
replace use2=use2*dyratio
replace use3=use3*dyratio
replace use4=use4*dyratio
replace use5=use5*dyratio
replace base=base*dyratio
 
drop dyratio start_date end_date

g mrgprc=r51A
replace mrgprc=r52A if use2>0.0001
replace mrgprc=r53A if use3>0.0001
replace mrgprc=r54A if use4>0.0001
replace mrgprc=r55A if use5>0.0001
 
*g mrgprc=0.1162 if CARE==0
*replace mrgprc=0.1361 if CARE==0 & use2>0.0001
*replace mrgprc=0.2201 if CARE==0 & use3>0.0001
*replace mrgprc=0.3049 if CARE==0 & use4>0.0001
*replace mrgprc=0.3049 if CARE==0 & use5>0.0001
 
*replace mrgprc=0.0834 if CARE==1
*replace mrgprc=0.1053 if CARE==1 & use2>0.0001
*replace mrgprc=0.1691 if CARE==1 & use3>0.0001
*replace mrgprc=0.1717 if CARE==1 & use4>0.0001
*replace mrgprc=0.1717 if CARE==1 & use5>0.0001
 
*g dmdcnst0=use
*g dmdcnst1=use/(mrgprc^-0.1)
g dmdcnst2=use/(mrgprc^-0.2)
g dmdcnst3=use/(mrgprc^-0.3)
 
summ use if use<0
 
keep id aid days use base dmd* CARE
 

g dmd2q5=dmdcnst2*r51A^-0.2 if dmdcnst2*r51A^-0.2<base
replace dmd2q5=base if dmdcnst2*r51A^-0.2>=base &  dmdcnst2*r52A^-0.2<=base
replace dmd2q5=dmdcnst2*r52A^-0.2 if dmdcnst2*r52A^-0.2>base &  dmdcnst2*r52A^-0.2<1.3*base
replace dmd2q5=1.3*base if dmdcnst2*r52A^-0.2>=1.3*base &  dmdcnst2*r53A^-0.2<=1.3*base
replace dmd2q5=dmdcnst2*r53A^-0.2 if dmdcnst2*r53A^-0.2>1.3*base &  dmdcnst2*r53A^-0.2<2*base
replace dmd2q5=2*base if dmdcnst2*r53A^-0.2>=2*base &  dmdcnst2*r54A^-0.2<=2*base
replace dmd2q5=dmdcnst2*r54A^-0.2 if dmdcnst2*r54A^-0.2>2*base &  dmdcnst2*r54A^-0.2<3*base
replace dmd2q5=3*base if dmdcnst2*r54A^-0.2>=3*base &  dmdcnst2*r55A^-0.2<=3*base
replace dmd2q5=dmdcnst2*r55A^-0.2 if dmdcnst2*r55A^-0.2>3*base 
 
g dmd2q2=dmdcnst2*r21A^-0.2 if dmdcnst2*r21A^-0.2<base
replace dmd2q2=base if dmdcnst2*r21A^-0.2>=base &  dmdcnst2*r22A^-0.2<=base
replace dmd2q2=dmdcnst2*r22A^-0.2 if dmdcnst2*r22A^-0.2>base 
 
g dmd2q1=dmdcnst2*r11A^-0.2 
 
 
 
g dmd3q5=dmdcnst3*r51A^-0.3 if dmdcnst3*r51A^-0.3<base
replace dmd3q5=base if dmdcnst3*r51A^-0.3>=base &  dmdcnst3*r52A^-0.3<=base
replace dmd3q5=dmdcnst3*r52A^-0.3 if dmdcnst3*r52A^-0.3>base &  dmdcnst3*r52A^-0.3<1.3*base
replace dmd3q5=1.3*base if dmdcnst3*r52A^-0.3>=1.3*base &  dmdcnst3*r53A^-0.3<=1.3*base
replace dmd3q5=dmdcnst3*r53A^-0.3 if dmdcnst3*r53A^-0.3>1.3*base &  dmdcnst3*r53A^-0.3<2*base
replace dmd3q5=2*base if dmdcnst3*r53A^-0.3>=2*base &  dmdcnst3*r54A^-0.3<=2*base
replace dmd3q5=dmdcnst3*r54A^-0.3 if dmdcnst3*r54A^-0.3>2*base &  dmdcnst3*r54A^-0.3<3*base
replace dmd3q5=3*base if dmdcnst3*r54A^-0.3>=3*base &  dmdcnst3*r55A^-0.3<=3*base
replace dmd3q5=dmdcnst3*r55A^-0.3 if dmdcnst3*r55A^-0.3>3*base 
 
g dmd3q2=dmdcnst3*r21A^-0.3 if dmdcnst3*r21A^-0.3<base
replace dmd3q2=base if dmdcnst3*r21A^-0.3>=base &  dmdcnst3*r22A^-0.3<=base
replace dmd3q2=dmdcnst3*r22A^-0.3 if dmdcnst3*r22A^-0.3>base 
 
g dmd3q1=dmdcnst3*r11A^-0.3 
 
* assume that demand is zero elasticity if use<0
 
replace dmd2q5=use if use<0
replace dmd2q2=use if use<0
replace dmd2q1=use if use<0
 
replace dmd3q5=use if use<0
replace dmd3q2=use if use<0
replace dmd3q1=use if use<0
 
 
 

**** CALC CHG IN CS BY CALC TOTAL CS BELOW P=0.5
 
g cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r51A^0.8)/0.8) if dmd2q5<base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r52A^0.8)/0.8) + base*(r52A-r51A) if dmd2q5>=base & dmd2q5<1.3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r53A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd2q5>=1.3*base & dmd2q5<2*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r54A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd2q5>=2*base & dmd2q5<3*base
replace cs2t5=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r55A^0.8)/0.8) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd2q5>=3*base
 
g cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r21A^0.8)/0.8) if dmd2q2<base
replace cs2t2=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r22A^0.8)/0.8) + base*(r22A-r21A) if dmd2q2>=base 
 
g cs2t1=(dmdcnst2*(0.5^0.8)/0.8)-(dmdcnst2*(r11A^0.8)/0.8) 
 

g cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r51A^0.7)/0.7) if dmd3q5<base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r52A^0.7)/0.7) + base*(r52A-r51A) if dmd3q5>=base & dmd3q5<1.3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r53A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) if dmd3q5>=1.3*base & dmd3q5<2*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r54A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) if dmd3q5>=2*base & dmd3q5<3*base
replace cs3t5=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r55A^0.7)/0.7) + base*(r52A-r51A) + 1.3*base*(r53A-r52A) + 2*base*(r54A-r53A) + 3*base*(r55A-r54A) if dmd3q5>=3*base
 
g cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r21A^0.7)/0.7) if dmd3q2<base
replace cs3t2=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r22A^0.7)/0.7) + base*(r22A-r21A) if dmd3q2>=base 
 
g cs3t1=(dmdcnst3*(0.5^0.7)/0.7)-(dmdcnst3*(r11A^0.7)/0.7) 
 

*counting solar "producer surplus" if use<0
 
replace cs2t5=-(use*r51A) if use<0
replace cs2t2=-(use*r21A) if use<0
replace cs2t1=-(use*r11A) if use<0
 
replace cs3t5=-(use*r51A) if use<0
replace cs3t2=-(use*r21A) if use<0
replace cs3t1=-(use*r11A) if use<0
 

summ
 
drop dmdcnst*
 
**** CALC REV PAID
g rv2t5=r51A*dmd2q5 if dmd2q5<base
replace rv2t5=r51A*base + r52A*(dmd2q5-base) if dmd2q5>=base & dmd2q5<1.3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A* (dmd2q5-1.3* base) if dmd2q5>=1.3*base & dmd2q5<2*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd2q5-2* base) if dmd2q5>=2*base & dmd2q5<3*base
replace rv2t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd2q5-3* base) if dmd2q5>=3*base
 
g rv2t2=r21A*dmd2q2 if dmd2q2<base
replace rv2t2=r21A*base + r22A*(dmd2q2-base) if dmd2q5>=base 
 
g rv2t1=r11A*dmd2q1
 

g rv3t5=r51A*dmd3q5 if dmd3q5<base
replace rv3t5=r51A*base + r52A*(dmd3q5-base) if dmd3q5>=base & dmd3q5<1.3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A* (dmd3q5-1.3* base) if dmd3q5>=1.3*base & dmd3q5<2*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*(dmd3q5-2* base) if dmd3q5>=2*base & dmd3q5<3*base
replace rv3t5=r51A*base + r52A*0.3*base + r53A*0.7*base + r54A*base + r55A*(dmd3q5-3* base) if dmd3q5>=3*base
 
g rv3t2=r21A*dmd3q2 if dmd3q2<base
replace rv3t2=r21A*base + r22A*(dmd3q2-base) if dmd3q5>=base 
 
g rv3t1=r11A*dmd3q1
 

capture append using CSchgA2
 
sort id aid CARE
 
collapse (sum) days use dmd* cs* rv*, by(id aid CARE)
 
compress
save CSchgA2, replace
 
local daycount=`daycount'+14
 

}
 

exit
